#include "hmg.ch"

Procedure MAIN // for test, usually Report_1

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   SET procedure to use_dbf // for test

   DEFINE WINDOW Rep_1 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 300 ;
      TITLE "EMPLOYE" ;
      MAIN  // for test, usually MODAL 

   @ 150, 150 BUTTON PRINT_9826 ;
      CAPTION " Create report " ;
      ACTION rep_create_9826() ;
      WIDTH 100

   END WINDOW

   Rep_1.CENTER
   ACTIVATE WINDOW Rep_1

RETURN
*----------------------------------------*
PROCEDURE rep_create_9826

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280
PRIVATE cFontName:="Courier", nFontSize:=10, nFontHeight:=5

USE_EMPLOYE()   // function from USE_DBF.prg 

set order to 2
dbgotop()

brk_01    := CLI_CITY  
brk_on_01 := .F.
prt_01    := .T.
sum_01_10 := 0 

sumr_10 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_10 := sumr_10 + CLI_SALARY

   IF brk_01 <> CLI_CITY  
      brk_on_01 := .T.
      prt_01    := .T.
   ENDIF

   IF brk_01 <> CLI_CITY .OR. brk_on_01

      nCurLine += nFontHeight
      @ nCurLine,   5 PRINT replicate("*", 10) FONT "Courier" SIZE 10
      @ nCurLine, 175 PRINT replicate("-", 10) FONT "Courier" SIZE 10

      nCurLine += nFontHeight
      @ nCurLine,   5 PRINT "sum" FONT "Courier" SIZE 10
      @ nCurLine, 175 PRINT  TRANSFORM ( sum_01_10, "99999.99") FONT "Courier" SIZE 10
      nCurLine += nFontHeight

      brk_01 := CLI_CITY  
      brk_on_01 := .F.
      sum_01_10 := 0 

   ENDIF

   sum_01_10 := sum_01_10 + CLI_SALARY

   IF nCurLine > nPageSize
      hdr_9826()
   ENDIF

   nCurLine += nFontHeight
   IF prt_01
      @ nCurLine,   5 PRINT  TRANSFORM ( CLI_CITY, "XXXXXXXXXX") FONT "Courier" SIZE 10
      prt_01 := .F.
   ENDIF
   @ nCurLine,  27 PRINT  TRANSFORM ( CLI_ID, "99999") FONT "Courier" SIZE 10
   @ nCurLine,  39 PRINT  TRANSFORM ( CLI_SNAM, "XXXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  65 PRINT  TRANSFORM ( CLI_NAME, "XXXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  91 PRINT  TRANSFORM ( CLI_TLF, "XXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine, 115 PRINT  TRANSFORM ( CLI_DAYS, "99") FONT "Courier" SIZE 10
   @ nCurLine, 121 PRINT  TRANSFORM ( CLI_WAGE, "9.99") FONT "Courier" SIZE 10
   @ nCurLine, 131 PRINT CLI_BDATE  FONT "Courier" SIZE 10
   @ nCurLine, 153 PRINT CLI_HDATE  FONT "Courier" SIZE 10
   @ nCurLine, 175 PRINT  TRANSFORM ( CLI_SALARY, "99999.99") FONT "Courier" SIZE 10

   DBSKIP()
ENDDO

nCurLine += nFontHeight
@ nCurLine,   5 PRINT replicate("*", 10) FONT "Courier" SIZE 10
@ nCurLine, 175 PRINT replicate("-", 10) FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "sum" FONT "Courier" SIZE 10
@ nCurLine, 175 PRINT  TRANSFORM ( sum_01_10, "99999.99") FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine, 175 PRINT replicate("=", 10) FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine, 175 PRINT  TRANSFORM ( sumr_10, "99999.99") FONT "Courier" SIZE 10

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_1.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_9826

nCurPage++
nCurLine := 1

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT "Courier" SIZE 10 
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT "Courier" SIZE 10
@ nCurLine, 100 PRINT "TITLE of Report" FONT "Courier" SIZE 14 CENTER

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "CLI_CITY" FONT "Courier" SIZE 10
@ nCurLine,  27 PRINT "CLI_I" FONT "Courier" SIZE 10
@ nCurLine,  39 PRINT "CLI_SNAM" FONT "Courier" SIZE 10
@ nCurLine,  65 PRINT "CLI_NAME" FONT "Courier" SIZE 10
@ nCurLine,  91 PRINT "CLI_TLF" FONT "Courier" SIZE 10
@ nCurLine, 115 PRINT "CL" FONT "Courier" SIZE 10
@ nCurLine, 121 PRINT "CLI_" FONT "Courier" SIZE 10
@ nCurLine, 131 PRINT "CLI_BDATE" FONT "Courier" SIZE 10
@ nCurLine, 153 PRINT "CLI_HDATE" FONT "Courier" SIZE 10
@ nCurLine, 175 PRINT "CLI_SALARY" FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,   5 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine,  27 PRINT replicate("=",  5) FONT "Courier" SIZE 10
@ nCurLine,  39 PRINT replicate("=", 12) FONT "Courier" SIZE 10
@ nCurLine,  65 PRINT replicate("=", 12) FONT "Courier" SIZE 10
@ nCurLine,  91 PRINT replicate("=", 11) FONT "Courier" SIZE 10
@ nCurLine, 115 PRINT replicate("=",  2) FONT "Courier" SIZE 10
@ nCurLine, 121 PRINT replicate("=",  4) FONT "Courier" SIZE 10
@ nCurLine, 131 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 153 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 175 PRINT replicate("=", 10) FONT "Courier" SIZE 10

prt_01 := .T.

RETURN 0
