#include <hmg.ch>

PROCEDURE MAIN // for test, usually edit_EMPLOYE

   PUBLIC New := .F. , _qry_exp := ""

   set procedure to Use_dbf.prg  // for test  

   Use_employe() ; // use_dbf.prg 

   DEFINE WINDOW Win_1 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 700 ;
      TITLE "Table EMPLOYE" ;
      MAIN  // for test, usually MODAL

      ON KEY ESCAPE ACTION Win_1.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Table EMPLOYE"
         KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 60,40 IMAGESIZE 32,32 FLAT BORDER

      BUTTON FIRST_4720 ;
         CAPTION "First" ;
         PICTURE "go_first.bmp" ;
         ACTION( dbGotop(), Win_1.Browse_1.Value := RecNo() )

      BUTTON PREV_4720 ;
         CAPTION "Prev" ;
         PICTURE "go_prev.bmp" ;
         ACTION( dbSkip( -1 ), Win_1.Browse_1.Value := RecNo() )

      BUTTON NEXT_4720 ;
         CAPTION "Next" ;
         PICTURE "go_next.bmp" ;
         ACTION( dbSkip(), if ( Eof(), dbGobottom(), Nil ), Win_1.Browse_1.Value := RecNo() )

      BUTTON LAST_4720 ;
         CAPTION "Last" ;
         PICTURE "go_last.bmp" ;
         ACTION( dbGoBottom(), Win_1.Browse_1.Value := RecNo() )   SEPARATOR 

      BUTTON FIND_4720 ;
         CAPTION "Find" ;
         PICTURE "edit_find.bmp" ;
         ACTION Find_4720()

      BUTTON NEW_4720 ;
         CAPTION "New" ;
         PICTURE "edit_new.bmp" ;
         ACTION ( New := .T., NewRecord_4720() )

      BUTTON EDIT_4720 ;
         CAPTION "Edit" ;
         PICTURE "edit_edit.bmp" ;
         ACTION If ( RecordStatus_4720(), EnableField_4720(), Nil )

      BUTTON DELETE_4720 ;
         CAPTION "Delete" ;
         PICTURE "edit_delete.bmp" ;
         ACTION ( RecordStatus_4720(), DeleteRecord_4720(), Nil )

      BUTTON PRINT_4720 ;
         CAPTION "Print" ;
         PICTURE "edit_print.bmp" ;
         ACTION PrintData_4720()

      BUTTON EXIT_4720 ;
         CAPTION "Exit" ;
         PICTURE "edit_close.bmp" ;
         ACTION Win_1.Release

      END TOOLBAR

      PaintDisplay_4720()

      @ 90,10 BROWSE Browse_1 ;
         OF Win_1 ;
         WIDTH 350 ;
         HEIGHT 450 ;
         FONT "Arial" ; 
         SIZE 11 ;
         HEADERS { "CLI_ID","CLI_SNAM","CLI_NAME","CLI_TLF","CLI_DAYS","CLI_WAGE","CLI_BDATE","CLI_HDATE","CLI_SALARY","CLI_CITY" } ;
         WIDTHS { 70,130,130,120,90,90,110,110,110,110 } ;
         WORKAREA EMPLOYE ;
         FIELDS { "CLI_ID","CLI_SNAM","CLI_NAME","CLI_TLF","CLI_DAYS","CLI_WAGE","CLI_BDATE","CLI_HDATE","CLI_SALARY","CLI_CITY" } ;
         ON CHANGE LoadData_4720() ;
         ON HEADCLICK { {||head1_4720()}, {||head2_4720()} } ;
         ON DBLCLICK ( EnableField_4720(), If ( ! RecordStatus_4720(), DisableField_4720(), Nil ) )

      @ 580, 50 BUTTON SAVE_4720 ;
         CAPTION "Save" ;
         PICTURE "ok.bmp" ;
         ACTION SaveRecord_4720() ;
         RIGHT ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,150 BUTTON CANCEL_4720 ;
         CAPTION "Cancel" ;
         PICTURE "cancel.bmp" ;
         ACTION CancelEdit_4720() ;
         RIGHT ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,300 BUTTON QUERY_4720 ;
         CAPTION "Query" ;
         PICTURE "edit_find.bmp" ;
         ACTION QueryRecord_4720() ;
         RIGHT ;
         WIDTH 100 ;
         HEIGHT 40 

   END WINDOW

   DisableField_4720()

   Win_1.Browse_1.SetFocus
   Win_1.Browse_1.Value := EMPLOYE->(RecNo())

   ACTIVATE WINDOW Win_1

RETURN
*---------------------------------------------*
PROCEDURE DisableField_4720

   Win_1.Browse_1.Enabled     := .T.

   Win_1.Control_1.Enabled    := .F.
   Win_1.Control_2.Enabled    := .F.
   Win_1.Control_3.Enabled    := .F.
   Win_1.Control_4.Enabled    := .F.
   Win_1.Control_5.Enabled    := .F.
   Win_1.Control_6.Enabled    := .F.
   Win_1.Control_7.Enabled    := .F.
   Win_1.Control_8.Enabled    := .F.
   Win_1.Control_9.Enabled    := .F.
   Win_1.Control_10.Enabled    := .F.

   Win_1.Save_4720.Enabled     := .F.
   Win_1.Cancel_4720.Enabled   := .F.
   Win_1.Query_4720.Enabled    := .F.
   Win_1.Toolbar_1.Enabled    := .T.
   Win_1.Browse_1.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE EnableField_4720

   Win_1.Browse_1.Enabled     := .F.

   Win_1.Control_1.Enabled    := .T.
   Win_1.Control_2.Enabled    := .T.
   Win_1.Control_3.Enabled    := .T.
   Win_1.Control_4.Enabled    := .T.
   Win_1.Control_5.Enabled    := .T.
   Win_1.Control_6.Enabled    := .T.
   Win_1.Control_7.Enabled    := .T.
   Win_1.Control_8.Enabled    := .T.
   Win_1.Control_9.Enabled    := .T.
   Win_1.Control_10.Enabled    := .T.

   Win_1.Save_4720.Enabled     := .T.
   Win_1.Cancel_4720.Enabled   := .T.
   Win_1.Query_4720.Enabled    := .F.
   Win_1.Toolbar_1.Enabled    := .F.
   Win_1.Control_2.SetFocus

RETURN
*---------------------------------------------*
FUNCTION RecordStatus_4720()

   Local RetVal

   EMPLOYE->( dbGoTo ( Win_1.Browse_1.Value ) )

   IF EMPLOYE->(RLock())
      RetVal := .T.
   ELSE
      MsgExclamation ("Record LOCKED, try again later")
      RetVal := .F.
   ENDIF

RETURN RetVal
*---------------------------------------------*
PROCEDURE LoadData_4720

   EMPLOYE->( dbGoTo ( Win_1.Browse_1.Value ) )

   Win_1.Control_1.Value    := EMPLOYE->CLI_ID    
   Win_1.Control_2.Value    := EMPLOYE->CLI_SNAM  
   Win_1.Control_3.Value    := EMPLOYE->CLI_NAME  
   Win_1.Control_4.Value    := EMPLOYE->CLI_TLF   
   Win_1.Control_5.Value    := EMPLOYE->CLI_DAYS  
   Win_1.Control_6.Value    := EMPLOYE->CLI_WAGE  
   Win_1.Control_7.Value    := EMPLOYE->CLI_BDATE 
   Win_1.Control_8.Value    := EMPLOYE->CLI_HDATE 
   Win_1.Control_9.Value    := EMPLOYE->CLI_SALARY
   Win_1.Control_10.Value    := EMPLOYE->CLI_CITY  

RETURN
*---------------------------------------------*
PROCEDURE CancelEdit_4720

   DisableField_4720()
   LoadData_4720()
   UNLOCK
   New := .F.

RETURN
*---------------------------------------------*
PROCEDURE SaveRecord_4720

   Local NewRecNo

   DisableField_4720()

   IF New == .T.
      EMPLOYE->(dbAppend())
      New := .F.
   ELSE
      EMPLOYE->(dbGoto ( Win_1.Browse_1.Value ) )
   ENDIF

   NewRecNo := EMPLOYE->( RecNo() )

   EMPLOYE->CLI_ID     := Win_1.Control_1.Value
   EMPLOYE->CLI_SNAM   := Win_1.Control_2.Value
   EMPLOYE->CLI_NAME   := Win_1.Control_3.Value
   EMPLOYE->CLI_TLF    := Win_1.Control_4.Value
   EMPLOYE->CLI_DAYS   := Win_1.Control_5.Value
   EMPLOYE->CLI_WAGE   := Win_1.Control_6.Value
   EMPLOYE->CLI_BDATE  := Win_1.Control_7.Value
   EMPLOYE->CLI_HDATE  := Win_1.Control_8.Value
   EMPLOYE->CLI_SALARY := Win_1.Control_9.Value
   EMPLOYE->CLI_CITY   := Win_1.Control_10.Value

   Win_1.Browse_1.Refresh
   IF New == .T.
      Win_1.Browse_1.Value := NewRecNo 
   ENDIF

   UNLOCK
   dbCommitall()

   Win_1.StatusBar.Item(1) := "Save Record" 

RETURN
*---------------------------------------------*
PROCEDURE NewRecord_4720

   Win_1.StatusBar.Item(1) := "Editing" 

   SET ORDER TO 1
   dbGoBottom()

   Win_1.Control_1.Value   := 0
   Win_1.Control_2.Value   := space(12)
   Win_1.Control_3.Value   := space(12)
   Win_1.Control_4.Value   := space(11)
   Win_1.Control_5.Value   := 0
   Win_1.Control_6.Value   := 0
   Win_1.Control_7.Value   := date()
   Win_1.Control_8.Value   := date()
   Win_1.Control_9.Value   := 0
   Win_1.Control_10.Value   := space(10)

   EnableField_4720()

   Win_1.Control_2.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE DeleteRecord_4720

   IF MsgYesNo ( "Are you sure do you want delete record?" )
      IF EMPLOYE->(FLock())
         DELETE
         Win_1.Browse_1.Refresh
         UNLOCK
      ENDIF
   ENDIF

RETURN
*---------------------------------------------*
PROCEDURE Find_4720

   Win_1.StatusBar.Item(1) := "Query" 

   Win_1.Control_1.Value   := 0
   Win_1.Control_2.Value   := space(12)
   Win_1.Control_3.Value   := space(12)
   Win_1.Control_4.Value   := space(11)
   Win_1.Control_5.Value   := 0
   Win_1.Control_6.Value   := 0
   Win_1.Control_7.Value   := date()
   Win_1.Control_8.Value   := date()
   Win_1.Control_9.Value   := 0
   Win_1.Control_10.Value   := space(10)

   EnableField_4720()
   Win_1.Save_4720.Enabled  := .F.
   Win_1.Query_4720.Enabled := .T.
   Win_1.Control_1.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE PrintData_4720

   Local RecRec 

   RecRec := EMPLOYE->( RecNo())
   dbGoTop()
   DO REPORT ;
      TITLE "EMPLOYE" ;
      HEADERS { "","","","","","","","","","" }, { "CLI_ID","CLI_SNAM","CLI_NAME","CLI_TLF","CLI_DAYS","CLI_WAGE","CLI_BDATE","CLI_HDATE","CLI_SALARY","CLI_CITY" } ;
      FIELDS { "CLI_ID","CLI_SNAM","CLI_NAME","CLI_TLF","CLI_DAYS","CLI_WAGE","CLI_BDATE","CLI_HDATE","CLI_SALARY","CLI_CITY" } ;
      WIDTHS { 7,13,13,12,9,9,11,11,11,11 } ;
      TOTALS { .F.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.F. } ;
      WORKAREA EMPLOYE ;
      LPP 50 ;
      CPL 80 ;
      LMARGIN 5 ;
      PREVIEW
   EMPLOYE->(dbGoTo(RecRec))

RETURN
*---------------------------------------------*
PROCEDURE PaintDisplay_4720

   @  90,410 FRAME Frame_1 WIDTH 300 HEIGHT 450

   @ 100, 420 LABEL Label_1 VALUE "CLI_ID"
   @ 130, 420 LABEL Label_2 VALUE "CLI_SNAM"
   @ 160, 420 LABEL Label_3 VALUE "CLI_NAME"
   @ 190, 420 LABEL Label_4 VALUE "CLI_TLF"
   @ 220, 420 LABEL Label_5 VALUE "CLI_DAYS"
   @ 250, 420 LABEL Label_6 VALUE "CLI_WAGE"
   @ 280, 420 LABEL Label_7 VALUE "CLI_BDATE"
   @ 310, 420 LABEL Label_8 VALUE "CLI_HDATE"
   @ 340, 420 LABEL Label_9 VALUE "CLI_SALARY"
   @ 370, 420 LABEL Label_10 VALUE "CLI_CITY"

   @ 100, 520 TEXTBOX  Control_1 NUMERIC INPUTMASK "99999"
   @ 130, 520 TEXTBOX  Control_2         INPUTMASK "!!!!!!!!!!!!"
   @ 160, 520 TEXTBOX  Control_3         INPUTMASK "!!!!!!!!!!!!"
   @ 190, 520 TEXTBOX  Control_4         INPUTMASK "!!!!!!!!!!!"
   @ 220, 520 TEXTBOX  Control_5 NUMERIC INPUTMASK "99"
   @ 250, 520 TEXTBOX  Control_6 NUMERIC INPUTMASK "9.99"
   @ 280, 520 TEXTBOX  Control_7 DATE 
   @ 310, 520 TEXTBOX  Control_8 DATE 
   @ 340, 520 TEXTBOX  Control_9 NUMERIC INPUTMASK "99999.99"
   @ 370, 520 TEXTBOX  Control_10         INPUTMASK "!!!!!!!!!!"

RETURN
*---------------------------------------------*
PROCEDURE Head1_4720

   SELECT EMPLOYE
   SET ORDER TO 1
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_4720()

RETURN
*---------------------------------------------*
PROCEDURE Head2_4720

   SELECT EMPLOYE
   SET ORDER TO 2
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_4720()

RETURN
*---------------------------------------------*
PROCEDURE QueryRecord_4720

   PreQuery_4720()

   SET FILTER TO 
   dbGotop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         Win_1.Statusbar.Item(1) := "Not found!"
      ELSE
         Win_1.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF

   DisableField_4720()

   Win_1.Browse_1.Refresh
   Win_1.Browse_1.Enabled   := .T.

RETURN
*---------------------------------------------*
PROCEDURE PreQuery_4720

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( Win_1.Control_1.Value )     // CLI_ID
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_ID = " + STR( Win_1.Control_1.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_2.Value )     // CLI_SNAM
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_SNAM = " + chr(34) + Win_1.Control_2.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_3.Value )     // CLI_NAME
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_NAME = " + chr(34) + Win_1.Control_3.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_4.Value )     // CLI_TLF
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_TLF = " + chr(34) + Win_1.Control_4.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_5.Value )     // CLI_DAYS
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_DAYS = " + STR( Win_1.Control_5.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_6.Value )     // CLI_WAGE
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_WAGE = " + STR( Win_1.Control_6.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_7.Value )     // CLI_BDATE
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_BDATE = " + "CTOD(" + chr(34) + DTOC(Win_1.Control_7.Value) + chr(34) + ")"
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_8.Value )     // CLI_HDATE
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_HDATE = " + "CTOD(" + chr(34) + DTOC(Win_1.Control_8.Value) + chr(34) + ")"
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_9.Value )     // CLI_SALARY
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_SALARY = " + STR( Win_1.Control_9.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.Control_10.Value )     // CLI_CITY
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "CLI_CITY = " + chr(34) + Win_1.Control_10.Value + chr(34)
      _ima_filter := .T.
ENDIF

RETURN
* end of program *