#include "hmg.ch"

Procedure MAIN // for test, usually Report_1

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   SET procedure to use_dbf // for test

   DEFINE WINDOW Rep_1 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 300 ;
      TITLE "EMPLOYE" ;
      MAIN  // for test, usually MODAL 

   @ 150, 150 BUTTON PRINT_9930 ;
      CAPTION " Create report " ;
      ACTION rep_create_9930() ;
      WIDTH 100

   END WINDOW

   Rep_1.CENTER
   ACTIVATE WINDOW Rep_1

RETURN
*----------------------------------------*
PROCEDURE rep_create_9930

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280
PRIVATE cFontName:="Courier", nFontSize:=10, nFontHeight:=5

USE_EMPLOYE()   // function from USE_DBF.prg 

sumr_09 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_09 := sumr_09 + CLI_SALARY

   IF nCurLine > nPageSize
      hdr_9930()
   ENDIF

   nCurLine += nFontHeight
   @ nCurLine,   5 PRINT  TRANSFORM ( CLI_ID, "99999") FONT "Courier" SIZE 10
   @ nCurLine,  17 PRINT  TRANSFORM ( CLI_SNAM, "XXXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  43 PRINT  TRANSFORM ( CLI_NAME, "XXXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  69 PRINT  TRANSFORM ( CLI_TLF, "XXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  93 PRINT  TRANSFORM ( CLI_DAYS, "99") FONT "Courier" SIZE 10
   @ nCurLine,  99 PRINT  TRANSFORM ( CLI_WAGE, "9.99") FONT "Courier" SIZE 10
   @ nCurLine, 109 PRINT CLI_BDATE  FONT "Courier" SIZE 10
   @ nCurLine, 131 PRINT CLI_HDATE  FONT "Courier" SIZE 10
   @ nCurLine, 153 PRINT  TRANSFORM ( CLI_SALARY, "99999.99") FONT "Courier" SIZE 10
   @ nCurLine, 175 PRINT  TRANSFORM ( CLI_CITY, "XXXXXXXXXX") FONT "Courier" SIZE 10

   DBSKIP()
ENDDO
nCurLine += nFontHeight

nCurLine += nFontHeight
@ nCurLine, 153 PRINT replicate("=", 10) FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine, 153 PRINT  TRANSFORM ( sumr_09, "99999.99") FONT "Courier" SIZE 10

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_1.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_9930

nCurPage++
nCurLine := 1

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT "Courier" SIZE 10 
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT "Courier" SIZE 10
@ nCurLine, 100 PRINT "TITLE of Report" FONT "Courier" SIZE 14 CENTER

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "CLI_I" FONT "Courier" SIZE 10
@ nCurLine,  17 PRINT "CLI_SNAM" FONT "Courier" SIZE 10
@ nCurLine,  43 PRINT "CLI_NAME" FONT "Courier" SIZE 10
@ nCurLine,  69 PRINT "CLI_TLF" FONT "Courier" SIZE 10
@ nCurLine,  93 PRINT "CL" FONT "Courier" SIZE 10
@ nCurLine,  99 PRINT "CLI_" FONT "Courier" SIZE 10
@ nCurLine, 109 PRINT "CLI_BDATE" FONT "Courier" SIZE 10
@ nCurLine, 131 PRINT "CLI_HDATE" FONT "Courier" SIZE 10
@ nCurLine, 153 PRINT "CLI_SALARY" FONT "Courier" SIZE 10
@ nCurLine, 175 PRINT "CLI_CITY" FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,   5 PRINT replicate("=",  5) FONT "Courier" SIZE 10
@ nCurLine,  17 PRINT replicate("=", 12) FONT "Courier" SIZE 10
@ nCurLine,  43 PRINT replicate("=", 12) FONT "Courier" SIZE 10
@ nCurLine,  69 PRINT replicate("=", 11) FONT "Courier" SIZE 10
@ nCurLine,  93 PRINT replicate("=",  2) FONT "Courier" SIZE 10
@ nCurLine,  99 PRINT replicate("=",  4) FONT "Courier" SIZE 10
@ nCurLine, 109 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 131 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 153 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 175 PRINT replicate("=", 10) FONT "Courier" SIZE 10


RETURN 0
